/*
doubleClick Version 1.07
Starting the Command Prompt window
Copyright 2017 Sogaya

Borland C++ 5.5.1 for Win32

*/

#define UM_TIME_START (WM_APP + 1) 
#include "doubleClick.h"

namespace {
    bool automaticStart, depressed, showWhere;
    char windowName[] = WINDOW_NAME;
    const BOOL REPAINT = TRUE;
    const std::string GAP(" ");
    HINSTANCE hInstance;
    HWND hwnd, textArea;
    int console_height, console_width, hidden, main_height, main_width, main_x, main_y, standard_main_x, standard_main_y, waiting, whichCorner;
    std::string exe, operand;
}

bool readBeforeCreatingWindows() {
    using namespace std;

// Reading doubleClick.txt before creating windows.
    char c[BUFFER_SIZE];
    const string command(COMMAND);
    const string commandSwitch(COMMAND_SWITCH);

    ifstream in(DOUBLE_CLICK_TEXT);
    if( in.fail() ) {
        return false;
    }

    in.getline(c, BUFFER_SIZE);

    string tail;
    string line(c);
    unsigned int q = line.find(GAP);
    if(q != string::npos) {
        exe = line.substr(0, q);
        q += GAP_SIZE;
        tail = line.substr(q);

        q = tail.find(GAP);
        if(q != string::npos) {
            operand = tail.substr(0, q);
        } else {
            q = tail.find(START);
            if(q != string::npos) {
                automaticStart = true;
                operand = tail.substr(0, q);
            } else {
                q = tail.find(START_CAPITAL_S);
                if(q != string::npos) {
                    automaticStart = true;
                    operand = tail.substr(0, q);
                } else {
                    automaticStart = false;
                    operand = tail;
                }

            }

        }

    } else {
        exe = command;
        operand = commandSwitch;
        automaticStart = false;
    }

    if( in.getline(c, BUFFER_SIZE) ) { 
        string milliseconds(c);
        stringstream ss(milliseconds);
        ss >> waiting;
        if(waiting < LOWER_LIMIT) {
            waiting = WAITING;
        } else if(UPPER_LIMIT < waiting) {
            waiting = WAITING;
        }

    } else {
        waiting = WAITING;
    }

    if( in.getline(c, BUFFER_SIZE) ) { 
        string minimize(c);
        stringstream ss(minimize);
        ss >> hidden;
        if(hidden < 0) {
            hidden = HIDDEN;
        } else if(3 < hidden) {
            hidden = HIDDEN;
        }

    } else {
        hidden = HIDDEN;
    }

    if( in.getline(c, BUFFER_SIZE) ) { 
        string width(c);
        stringstream ss(width);
        ss >> console_width;
        if(console_width < 0) {
            console_width = CONSOLE_WIDTH;
        } else if(667 < console_width) {
            console_width = CONSOLE_WIDTH;
        }

    } else {
        console_width = CONSOLE_WIDTH;
    }

    const int SCREEN_HEIGHT = ::GetSystemMetrics(SM_CYFULLSCREEN);
    if( in.getline(c, BUFFER_SIZE) ) { 
        string height(c);
        stringstream ss(height);
        ss >> console_height;
        if(console_height < 0) {
            console_height = CONSOLE_HEIGHT;
        } else if(SCREEN_HEIGHT < console_height) {
            console_height = CONSOLE_HEIGHT;
        }

    } else {
        console_height = CONSOLE_HEIGHT;
    }

    return true;
}

bool startDepressed() {
    const int BORDER = 4;
    const int BUTTON_HEIGHT = 27;
    const int BUTTON_LEFT = 213;
    const int BUTTON_TOP = 68;
    const int BUTTON_WIDTH = 65;
    const int HEAD = 40;
    POINT pos;
    RECT windowRect;

    ::GetWindowRect(hwnd, &windowRect);
    ::GetCursorPos(&pos);

    int upper_left_x = windowRect.left + BUTTON_LEFT + BORDER;
    int upper_left_y = windowRect.top + HEAD + BUTTON_TOP + BORDER;
    int upper_right_x = upper_left_x + BUTTON_WIDTH;
    int lower_left_y = upper_left_y + BUTTON_HEIGHT;
    bool inside = false;
    if(upper_left_x < pos.x && pos.x < upper_right_x) {
        if(upper_left_y < pos.y && pos.y < lower_left_y) {
            inside = true;
        }

    }

    return inside;
}

bool startHandler() {
    executeProgram(exe, operand);

    bool taskCompleted;
    if(showWhere) {
        taskCompleted = false;
    } else {
        taskCompleted = true;
    }

    if(whichCorner == 0) {
        taskCompleted = centeringSmallConsole(hidden);
    }

    closing(taskCompleted);
    return taskCompleted;
}

int WINAPI WinMain(HINSTANCE instance, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode) {
    using namespace std;

    bool acrobat = false;
    bool not_automatically = false;
    bool show_where = false;
    char buffer[BUFFER_SIZE];
    const bool EXECUTABLE = true;
    const bool WITHOUT_COMMENTS = false;
    const bool WITH_COMMENTS = true;
    const string ACROBAT("-a");
    const string DIAGONAL("-d");
    const string EMPTY("");
    const string helpFileName(HELP_FILE_NAME);
    const string MANUAL_START("-s-");
    const string PDF("-p");
    const string WHERE("-w");
    const string version_comment("-VC");
    const string version_guide("-V");
    Numbered *n = new Numbered("-d3");
    Split a( ::GetCommandLine(), " ", EXECUTABLE);
    int argc = a.count();
    int q;
    string non_number, s;
    for(int i = 0; i < argc; ++i) {
        if( ACROBAT == a.argument(i) ) {
            acrobat = true;
        } else if( MANUAL_START == a.argument(i) ) {
            not_automatically = true;
        } else if( PDF == a.argument(i) ) {
            acrobat = true;
        } else if( WHERE == a.argument(i) ) {
            show_where = true;
        } else if( version_guide == a.argument(i) ) {
            guide(WITHOUT_COMMENTS);
            delete n;
            return 0;

        } else if( version_comment == a.argument(i) ) {
            guide(WITH_COMMENTS);
            delete n;
            return 0;

        } else {
            s = a.argument(i);
            q = s.find(DIAGONAL);
            if(q != string::npos) {
                delete n;
                strcpy(buffer, s.c_str() );
                n = new Numbered(buffer);
                whichCorner = n->number();
                if( n->parameter() == DIAGONAL ) {
                    not_automatically = true;
                    continue;
                }

                whichCorner = 0; // center
            }

        }

    }

    delete n;

// Selecting COMMAND or HELP_FILE_NAME
    if(acrobat) {
        automaticStart = true;
        exe = helpFileName;
        operand = EMPTY;
    } else { // COMMAND
        if( readBeforeCreatingWindows() ) {
            if(not_automatically) {
                automaticStart = false;
            }

            showWhere = show_where;
        } else {
            createDoubleClickText();
        }

    }

// Creatring a window
    MSG msg;
    WNDCLASSEX wcl;
    HACCEL hAccel;

    wcl.cbSize = sizeof(WNDCLASSEX);

    wcl.hInstance = instance;
    wcl.lpszClassName = windowName;
    wcl.lpfnWndProc = WindowFunc;
    wcl.style = 0;

    wcl.hIcon = ::LoadIcon(instance, "GizeIcon");
    wcl.hIconSm = NULL;
    wcl.hCursor = ::LoadCursor(NULL, IDC_ARROW);

    wcl.lpszMenuName = "doubleClickMenu";
    wcl.cbClsExtra = 0;
    wcl.cbWndExtra = 0;

    wcl.hbrBackground = (HBRUSH) ::GetStockObject(WHITE_BRUSH);

    if(! ::RegisterClassEx(&wcl) ) {
        return 0; // error
    }

    int windowStyle = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU;
    main_width = MAIN_WIDTH;
    main_height = MAIN_HEIGHT;
    standard_main_x = MAIN_X;
    standard_main_y = MAIN_Y;
    hwnd = ::CreateWindow(
        windowName,
        WINDOW_NAME, 
        windowStyle, 
        standard_main_x, 
        standard_main_y, 
        main_width, 
        main_height, 
        NULL, 
        NULL, 
        instance, 
        NULL
    );

    hInstance = instance;

    hAccel = ::LoadAccelerators(instance, "doubleClickMenu");

    switch(whichCorner) {
    case 1:
        cornerHandler(hwnd);
        break;
    case 2:
        rightHandler(hwnd);
        break;
    case 3:
        diagonalHandler(hwnd);
        break;
    case 4:
        underHandler(hwnd);
        break;
    default:
        centering(hwnd);
        break;
    }

    ::ShowWindow(hwnd, nWinMode);
    ::UpdateWindow(hwnd);

    while( ::GetMessage(&msg, NULL, 0, 0) ) {
        if(! ::TranslateAccelerator(hwnd, hAccel, &msg) ) {
            ::TranslateMessage(&msg);
            ::DispatchMessage(&msg);
        }

    }

    return msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {
    char data[BUFFER_SIZE];
    const bool TASK_COMPLETED = true;
    HBITMAP hBitmap;
    HDC hdc, memdc;
    PAINTSTRUCT paintStruct;
    std::string label = exe + GAP + operand;

    switch(message) {
    case UM_TIME_START:
        startHandler();
        break;
    case WM_CHAR:
        switch( (char)wParam ) {
        case '-':
            startHandler();
            break;
        }

        break;
    case WM_COMMAND:
        switch( LOWORD(wParam) ) {
        case IDM_CLOSE:
            closing(TASK_COMPLETED);
            break;
        case IDM_HELP:
            helpHandler(wParam);
            break;
        case IDM_START:
            startHandler();
            break;
        }

        break;
    case WM_CREATE:
        textArea = ::CreateWindow(
            "STATIC",
            "",
            WS_CHILD | WS_VISIBLE | SS_LEFT,
            0, TEXT_AREA_TOP, TEXT_AREA_WIDTH, TEXT_AREA_HEIGHT,
            hwnd,
            (HMENU)IDM_LABEL,
            hInstance,
            NULL
        );

        ::SetWindowText(textArea, label.c_str() );

// Updating
        layout();
        depressed = false;

        if(automaticStart) {
            ::SetTimer(hwnd, IDM_TIMER, waiting, (TIMERPROC)TimerProc);
        }

        if(showWhere) {
            ::SetTimer(hwnd, IDM_SHOW_WHERE_TIMER, NON_SAMPLING_PERIOD, (TIMERPROC)showWhereCursor);
        }

        break;
    case WM_DESTROY:
        closing(TASK_COMPLETED);
        break;
    case WM_KEYDOWN:
        switch( (char)wParam ) {
        case VK_F11:
            strcpy(data, WINDOW_NAME);
            strcat(data, " ");
            strcat(data, VERSION);
            ::SetWindowText(hwnd, data);
            break;
        case VK_NEXT: // Page Down
            ::PostQuitMessage(0);
            break;
        case VK_SHIFT:
            ::SetWindowText(hwnd, WINDOW_NAME);
            break;
        }

        break;
    case WM_LBUTTONDOWN:
        depressed = startDepressed();
        if(depressed) {
            ::InvalidateRect(hwnd, NULL, TRUE);
        }

        break;
    case WM_LBUTTONUP:
        depressed = startDepressed();
         if(depressed) {
            startHandler();
            depressed = false;
        } else {
            ::InvalidateRect(hwnd, NULL, TRUE);
        }

        break;
    case WM_PAINT:
        if(depressed) {
            hBitmap = ::LoadBitmap(hInstance, "startDepressed");
        } else {
            hBitmap = ::LoadBitmap(hInstance, "start");
        }

        hdc = ::BeginPaint(hwnd, &paintStruct);
        memdc = ::CreateCompatibleDC(hdc);
        ::SelectObject(memdc, hBitmap);

// Painting
        ::BitBlt(hdc, 0, 0, TEXT_AREA_WIDTH, TEXT_AREA_TOP, memdc, 0, 0, SRCCOPY);

        ::DeleteObject(hBitmap);
        ::EndPaint(hwnd, &paintStruct);
        ::DeleteDC(memdc);
        break;
    case WM_SIZE:
        layout();
        break;
    default:
        return ::DefWindowProc(hwnd, message, wParam, lParam);
    }

    return 0;
}

VOID CALLBACK showWhereCursor(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
    const int BORDER = ::GetSystemMetrics(SM_CYSIZEFRAME);
    const int TITLE_BAR_HEIGHT = ::GetSystemMetrics(SM_CYCAPTION);
    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int HEAD = BORDER + TITLE_BAR_HEIGHT + MENU_HEIGHT;
    POINT pos;
    RECT windowRect;

    ::GetWindowRect(hwnd, &windowRect);
    ::GetCursorPos(&pos);

    bool through = false;
    char buffer[BUFFER_SIZE];
    int upper_left_x = windowRect.left;
    int upper_left_y = windowRect.top + HEAD;
    int upper_right_x = windowRect.right;
    int lower_left_y = windowRect.bottom - BORDER;
    if(upper_left_x < pos.x && pos.x < upper_right_x) {
        if(upper_left_y < pos.y && pos.y < lower_left_y) {
            through = true;
        }

    }

    if(through) {
        wsprintf(buffer, "%d : %d ( inside ) ", pos.x, pos.y);
    } else {
        wsprintf(buffer, "%d : %d ( outside ) ", pos.x, pos.y);
    }

    ::SetWindowText(hwnd, buffer);
}

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
    ::KillTimer(hwnd, IDM_TIMER);
    ::PostMessage(hwnd, UM_TIME_START, (WPARAM)0, (LPARAM)0);
}

void centering(HWND hwnd) {
    const int HALF_WIDTH = main_width/2;
    const int HALF_HEIGHT = main_height/2;
    const int MENU_BAR_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    const int TITLE_BAR_HEIGHT = ::GetSystemMetrics(SM_CYCAPTION);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_BAR_HEIGHT;
    screen_height += TITLE_BAR_HEIGHT;
    main_x = SCREEN_WIDTH/2 - HALF_WIDTH;
    main_y = screen_height/2 - HALF_HEIGHT;

    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);

    standard_main_x = main_x;
    standard_main_y = main_y;
}

bool centeringSmallConsole(int hidden) {
    const int HALF_WIDTH = console_width/2;
    const int HALF_HEIGHT = console_height/2;
    const int MENU_BAR_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    const int TITLE_BAR_HEIGHT = ::GetSystemMetrics(SM_CYCAPTION);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_BAR_HEIGHT;
    screen_height += TITLE_BAR_HEIGHT;

    HWND hwnd = ::FindWindow("ConsoleWindowClass", NULL);
    int count = 1;
    while(hwnd == NULL) {
        Sleep(600);
        hwnd = ::FindWindow("ConsoleWindowClass", NULL);
        count += 1;
        if(count == FIND_WINDOW_MANY_TIMES) {
            break;
        }

    }

    ::ShowWindow(hwnd, SW_RESTORE);
    int console_x = SCREEN_WIDTH/2 - HALF_WIDTH;
    int console_y = screen_height/2 - HALF_HEIGHT;

    bool task_completed = true;
    switch(hidden) {
    case 1:
        ::SetWindowPos(hwnd, HWND_BOTTOM, console_x, console_y, console_width, console_height, 0);
        ::ShowWindow(hwnd, SW_MINIMIZE);
        break;
    case 2:
        ::SetWindowPos(hwnd, HWND_BOTTOM, console_x, console_y, console_width, console_height, 0);
        break;
    case 3:
        ::SetWindowPos(hwnd, HWND_BOTTOM, console_x, console_y, console_width, console_height, SWP_HIDEWINDOW);
        task_completed = false;
        break;
    default:
        ::SetWindowPos(hwnd, HWND_TOP, console_x, console_y, console_width, console_height, 0);
        break;
    }

    return task_completed;
}

void closing(bool task_completed) {
    if(task_completed) {
        ::PostQuitMessage(0);
    }

}

void cornerHandler(HWND hwnd) {
    whichCorner = 1;

    main_x = 0;
    main_y = 0;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void createDoubleClickText() {
    using namespace std;

    const string EXE(COMMAND);
    const string OPERAND(COMMAND_SWITCH);
    ofstream file(DOUBLE_CLICK_TEXT);

    exe = EXE;
    operand = OPERAND;
    automaticStart = true;
    file << EXE << GAP << OPERAND << START_CAPITAL_S << endl;

    showWhere = false;
    waiting = WAITING;
    file << WAITING << endl;

    hidden = HIDDEN;
    file << HIDDEN << endl;

    console_width = CONSOLE_WIDTH;
    file << CONSOLE_WIDTH << endl;

    console_height = CONSOLE_HEIGHT;
    file << CONSOLE_HEIGHT << endl;
}

void guide(bool comment) {
    using namespace std;

    ofstream file(VERSION_TEXT);
    file << "doubleClick Version " << VERSION << "\n" << endl;
    if(comment) {
        file << "doubleClick        # Decide according to doubleClick.txt " << endl 
            << "doubleClick -p     # PDF help " << endl 
            << "doubleClick -s-    # manual start " << endl 
            << "doubleClick -d3    # diagonal " << endl 
            << "doubleClick -d3 -w # Show where the cursor is. " << endl 
            << "doubleClick -V     # version " << endl 
            << "doubleClick -VC    # version with comments " << endl;
    } else {
        file << "doubleClick        " << endl 
            << "doubleClick -p     " << endl 
            << "doubleClick -s-    " << endl 
            << "doubleClick -d3    " << endl 
            << "doubleClick -d3 -w " << endl 
            << "doubleClick -V     " << endl 
            << "doubleClick -VC    " << endl;
    }

}

void diagonalHandler(HWND hwnd) {
    whichCorner = 3;

    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    ::ShowWindow(hwnd, SW_RESTORE);

    main_x = SCREEN_WIDTH - main_width;
    main_y = screen_height - main_height;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void helpHandler(WPARAM wParam) {
    executeProgram(HELP_FILE_NAME, "");
}

void layout() {
    RECT windowRect;

    ::GetClientRect(hwnd, &windowRect);
    ::MoveWindow(textArea, 0, TEXT_AREA_TOP, windowRect.right, TEXT_AREA_HEIGHT, REPAINT);
}

void rightHandler(HWND hwnd) {
    whichCorner = 2;

    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);

    ::ShowWindow(hwnd, SW_RESTORE);

    main_x = SCREEN_WIDTH - main_width;
    main_y = 0;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void executeProgram(const char *p, const char *q) {
    char FileName[SMALL_BUFFER_SIZE];
    char Parameters[SMALL_BUFFER_SIZE];
    strcpy(FileName, p);
    strcpy(Parameters, q);

    SHELLEXECUTEINFO execinfo;
    memset(&execinfo, 0, sizeof(execinfo) );
    execinfo.cbSize = sizeof(execinfo);
    execinfo.fMask = SEE_MASK_NOCLOSEPROCESS;
    execinfo.lpFile = FileName;
    execinfo.lpParameters = Parameters;
    execinfo.lpVerb = "open";
    execinfo.nShow = SW_SHOWDEFAULT;
    ::ShellExecuteEx(&execinfo);
}

void executeProgram(std::string & e, std::string & o) {
    executeProgram( e.c_str(), o.c_str() );
}

void underHandler(HWND hwnd) {
    whichCorner = 4;

    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    ::ShowWindow(hwnd, SW_RESTORE);

    main_x = 0;
    main_y = screen_height - main_height;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}
