package info.lotosummary.software;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;

public class GizeFrame_CsvBox extends JDialog implements ActionListener {
    static final int COMMA_SIZE = 1;
    static final int CSV_COLUMN_COUNT = 7;
    static final String COMMA = ",";
    static final String DOUBLE_CLICK_ACROBAT = "doubleClick.exe -p";
    static final String ERROR_TEXT = "error.txt";
    static final String NO_ERROR = "No error";
    static final String[] COLUMN_NAMES = {"Lines", "Bingo-5", "QP", "Date", "ID", "Res-number", "Name"};

    private BorderLayout borderLayout1 = new BorderLayout();
    private DefaultTableModel tableModel1;
    private JButton helpButton = new JButton();
    private JButton closeButton = new JButton();
    private JLabel eastLabel = new JLabel();
    private JLabel southLabel = new JLabel();
    private JPanel borderLayoutPanel = new JPanel();
    private JScrollPane jScrollPane1 = new JScrollPane(); // CSV

    int ROW_COUNT;
    String error, name_of_CSV;
    String[] table;

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e47) {
            error = "Exception e47: " + ERROR_TEXT;
            return false;
        }

    }

    public void setting(String[] t, String n, int r) {
        ROW_COUNT = r;
        name_of_CSV = n;
        table = t;

        int row_count = table.length;
        if(row_count > ROW_COUNT) {
            row_count = ROW_COUNT;
        }

        for(int i = 0; i < row_count; ++i) {
            tableModel1.addRow( septet(table[i]) );
        }

        southLabel.setText(name_of_CSV);
    }

    public GizeFrame_CsvBox(Frame parent) {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        } catch(Exception e57) {
            error = "Exception e57";
        }

    }

    private void jbInit() throws Exception  {
        this.setTitle("Csv");
        borderLayoutPanel.setLayout(borderLayout1);
        helpButton.setText("Help");
        helpButton.addActionListener(this);
        closeButton.setText("Close");
        closeButton.addActionListener(new GizeFrame_CsvBox_closeButton_actionAdapter(this));
        eastLabel.setForeground(SystemColor.inactiveCaptionText);
        eastLabel.setText("------------------------------------------------------------------------------------------"); // 90 hyphens
        this.getContentPane().add(borderLayoutPanel, null);
        borderLayoutPanel.add(jScrollPane1, BorderLayout.NORTH);
        borderLayoutPanel.add(helpButton,  BorderLayout.WEST);
        borderLayoutPanel.add(closeButton,  BorderLayout.CENTER);
        borderLayoutPanel.add(eastLabel, BorderLayout.EAST);
        borderLayoutPanel.add(southLabel,  BorderLayout.SOUTH);

        tableModel1 = new DefaultTableModel(COLUMN_NAMES, 0);
        JTable jTable1 = new JTable(tableModel1);
        jScrollPane1.getViewport().add(jTable1, null);
        southLabel.setText("who1-23-45.csv");
        error = NO_ERROR;
        setResizable(true);
    }

    private String[] septet(String item) {
       int q;
       String tail = new String(item);
       String[] c = new String[CSV_COLUMN_COUNT];
       String[] empty = {"", "", "", "", "", "", ""};

       for(int i = 0; i < CSV_COLUMN_COUNT; ++i) {
           q = tail.indexOf(COMMA);
           if(q >= 0) {
               c[i] = tail.substring(0, q);
               q += COMMA_SIZE;
               tail = tail.substring(q);
           } else {
               return empty;
           }

        }

        return c;
    }

    protected void processWindowEvent(WindowEvent e) {
        if ( e.getID() == WindowEvent.WINDOW_CLOSING ) {
            cancel();
        }
        super.processWindowEvent(e);
    }

    void cancel() {
        dispose();
    }

    public void actionPerformed(ActionEvent e) {
        if ( e.getSource() == helpButton ) {
            try {
                Runtime rt = Runtime.getRuntime();
                rt.exec(DOUBLE_CLICK_ACROBAT);
            } catch (SecurityException e58) {
                southLabel.setText("SecurityException e58");
            } catch (IOException e62) {
                southLabel.setText("IOException e62");
            }

            cancel();
        }
    }

    void closeButton_actionPerformed(ActionEvent e) {
        if ( e.getSource() == closeButton ) {
            cancel();
        }

    }

}

class GizeFrame_CsvBox_closeButton_actionAdapter implements java.awt.event.ActionListener {
    private GizeFrame_CsvBox adaptee;

    GizeFrame_CsvBox_closeButton_actionAdapter(GizeFrame_CsvBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.closeButton_actionPerformed(e);
    }

}
