package info.lotosummary.software;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

public class GizeFrame_ManageBox extends JDialog implements ActionListener {
    static final int MANAGE_TEXT_LINE_COUNT = 13;
    static final int NOT_CONVERTED = -1;
    static final int SHOW_MESSAGES = 3000;
    static final String DOUBLE_CLICK_ACROBAT = "doubleClick.exe -p";
    static final String ERROR_TEXT = "error.txt";
    static final String MANAGE_TEXT = "manage.txt";
    static final String NO_ERROR = "No error";

    private BorderLayout borderLayout1 = new BorderLayout();
    private GridLayout gridLayout1 = new GridLayout();
    private JButton helpButton = new JButton();
    private JButton saveButton = new JButton();
    private JCheckBox jCheckBox1 = new JCheckBox();
    private JCheckBox jCheckBox2 = new JCheckBox();
    private JCheckBox jCheckBox3 = new JCheckBox();
    private JCheckBox jCheckBox4 = new JCheckBox();
    private JCheckBox jCheckBox5 = new JCheckBox();
    private JLabel eastLabel = new JLabel();
    private JLabel southLabel = new JLabel();
    private JPanel northPanel = new JPanel();
    private JPanel borderLayoutPanel = new JPanel();

    boolean cell_5, noSplitting, preedit, ticketForm, whoText;
    int NEW_LINE_LENGTH;
    String error, FULL_PATH_NAME, NEW_LINE;
    String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "2", // m[3], lines
            "0", // m[4], cell_5
            "1", // m[5], firstLine
            "0", // m[6], noSplitting
            "1", // m[7], preedit
         "5000", // m[8], rowCount
            "1", // m[9], serialNumber
            "0", // m[10], ticketForm
            "0", // m[11], whoText
            "1", // m[12], toGize
            "0"  // m[13], whichCorner
        };

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e48) {
            error = "Exception e48: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            return true;
        } catch(IOException e13) {
            error = "IOException e13: " + FULL_PATH_NAME;
            createErrorText(error);
            return false;
        }

    }

    private boolean writeManageText() {
        m[4] = cell_5 ? "1" : "0";
        m[6] = noSplitting ? "1" : "0"; // Date
        m[7] = preedit ? "1" : "0";
        m[10] = ticketForm ? "1" : "0"; // Matrix
        m[11] = whoText ? "1" : "0"; // Overwrite

// Creating MANAGE_TEXT
        StringBuffer os = new StringBuffer();
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            os.append(m[line]);
            os.append(NEW_LINE);
        }

        String s = os.toString();
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(MANAGE_TEXT) );
            file.write(s);
            file.close();
            return true;
        } catch(Exception e49) {
            error = "Exception e49: " + MANAGE_TEXT;
            createErrorText(error);
            return false;
        }

    }

    private int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e1) {
            error = "NumberFormatException e1";
            return NOT_CONVERTED;
        }

    }

    public void setting(String f, boolean c, boolean n, boolean p, boolean ti, boolean w) {
        FULL_PATH_NAME = f;
        cell_5 = c;
        noSplitting = n;
        preedit = p;
        ticketForm = ti;
        whoText = w;

        jCheckBox1.setSelected(cell_5);
        jCheckBox2.setSelected(noSplitting);
        jCheckBox3.setSelected(preedit);
        jCheckBox4.setSelected(ticketForm);
        jCheckBox5.setSelected(whoText);
    }

    public GizeFrame_ManageBox(Frame parent) {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        } catch(Exception e64) {
            error = "Exception e64";
        }

    }

    private void jbInit() throws Exception  {
        this.setTitle("Manage");
        borderLayoutPanel.setLayout(borderLayout1);
        helpButton.setText("Help");
        helpButton.addActionListener(this);
        saveButton.setText("Save");
        saveButton.addActionListener(new GizeFrame_ManageBox_saveButton_actionAdapter(this));
        eastLabel.setForeground(SystemColor.inactiveCaptionText);
        eastLabel.setText("---------------");
        northPanel.setLayout(gridLayout1);
        jCheckBox1.setText("Cell-5");
        jCheckBox2.setText("Date"); // noSplitting
        jCheckBox3.setText("Preedit");
        jCheckBox4.setText("Matrix"); // ticketForm
        jCheckBox5.setText("Overwrite"); // whoText
        gridLayout1.setColumns(1);
        gridLayout1.setRows(5);
        this.getContentPane().add(borderLayoutPanel, null);
        borderLayoutPanel.add(northPanel, BorderLayout.NORTH);
        northPanel.add(jCheckBox1, null);
        northPanel.add(jCheckBox2, null);
        northPanel.add(jCheckBox3, null);
        northPanel.add(jCheckBox4, null);
        northPanel.add(jCheckBox5, null);
        borderLayoutPanel.add(helpButton,  BorderLayout.WEST);
        borderLayoutPanel.add(saveButton,  BorderLayout.CENTER);
        borderLayoutPanel.add(eastLabel, BorderLayout.EAST);
        borderLayoutPanel.add(southLabel,  BorderLayout.SOUTH);

        error = NO_ERROR;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();

        southLabel.setText(MANAGE_TEXT);
        setResizable(false);
    }

    protected void processWindowEvent(WindowEvent e) {
        if ( e.getID() == WindowEvent.WINDOW_CLOSING ) {
            cancel();
        }
        super.processWindowEvent(e);
    }

    void cancel() {
        dispose();
    }

    public void actionPerformed(ActionEvent e) {
        if ( e.getSource() == helpButton ) {
            try {
                Runtime rt = Runtime.getRuntime();
                rt.exec(DOUBLE_CLICK_ACROBAT);
            } catch (SecurityException e59) {
                southLabel.setText("SecurityException e59");
            } catch (IOException e65) {
                southLabel.setText("IOException e65");
            }

            cancel();
        }

    }

    void saveButton_actionPerformed(ActionEvent e) {
        if ( e.getSource() == saveButton ) {
            cell_5 = jCheckBox1.isSelected();
            noSplitting = jCheckBox2.isSelected();
            preedit = jCheckBox3.isSelected();
            ticketForm = jCheckBox4.isSelected();
            whoText = jCheckBox5.isSelected();

            if( readManageText() ) {
                if( writeManageText() ) {
                    ;
                } else {
                    southLabel.setText(error);
                    try{
                        Thread.sleep(SHOW_MESSAGES);
                    } catch(InterruptedException e66) {
                        ;
                    }

                }

            } else {
                return;
            }

            cancel();
        }

    }
}

class GizeFrame_ManageBox_saveButton_actionAdapter implements java.awt.event.ActionListener {
    private GizeFrame_ManageBox adaptee;

    GizeFrame_ManageBox_saveButton_actionAdapter(GizeFrame_ManageBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.saveButton_actionPerformed(e);
    }

}
