package info.lotosummary.software;
import java.io.*;

public class Optional {
    static final int COMMAND_PARAMETER_ARRAY_SIZE = 64;
    static final int ERROR_CODE = 1;
    static final int LINES = 2;
    static final int MANAGE_TEXT_LINE_COUNT = 13;
    static final int NOT_CONVERTED = -1;
    static final int OPTIONAL_TEXT_LINE_COUNT = 36;
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String EXCLUDE_TEXT = "exclude.txt";
    static final String FALSE = "0";
    static final String GAP_TAB = " \t";
    static final String MANAGE_TEXT = "manage.txt";
    static final String NO_ERROR = "No error";
    static final String WHO_TEXT = "who.txt";

    boolean cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, whoText;
    int lines, NEW_LINE_LENGTH, rowCount;
    String fileName, error, FULL_PATH_NAME, list_of_items, NEW_LINE, OPTIONAL_TEXT;
    String[] falseString;
    String[] optional;

    String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "2", // m[3], lines
            "0", // m[4], cell_5
            "1", // m[5], firstLine
            "0", // m[6], noSplitting
            "1", // m[7], preedit
         "5000", // m[8], rowCount
            "1", // m[9], serialNumber
            "0", // m[10], ticketForm
            "0", // m[11], whoText
            "1", // m[12], toGize
            "0"  // m[13], whichCorner
        };

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e39) {
            error = "Exception e39: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            return true;
        } catch(IOException e35) {
            error = "IOException e35: " + FULL_PATH_NAME;
            createErrorText(error);
            return false;
        }

    }

    private int sequenceOfDelimiters(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = GAP_TAB.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_delimiters(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = GAP_TAB.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 0; i < COMMAND_PARAMETER_ARRAY_SIZE; ++i) {
            n = sequence_of_non_delimiters(line, p);
            from = p;
            p += n;

            u = sequenceOfDelimiters(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e73) {
            error = "NumberFormatException e73";
            return NOT_CONVERTED;
        }

    }

    public OptionalCode command(String commandLine) {
        String[] args = dividing(commandLine);

        boolean destroyWhoText = false;
        boolean toGize = true;
        int count = args.length;
        int q;
        int whichCorner = 0; // centering
        Numbered n;
        String argument;
        String COUNT = "-c";
        String DIAGONAL = "-d";
        String CSV = "--csv";
        String EXCLUDE = "-e";
        String FREE = "-f";
        String NO_EDITING = "-e-";
        String NO_PREEDITING = "-p-";
        String NO_SPLITTING = "-s-";
        String OVERWRITE = "-o";
        String QUIT = "-q";
        String REMOVE_LINE_1 = "-1-";
        String TABLE = "-a";
        String TICKET = "-t";

        cell_5 = false;
        csv = false;
        error = NO_ERROR;
        fileName = WHO_TEXT;
        firstLine = true;
        lines = LINES;
        list_of_items = EXCLUDE_TEXT;
        noSplitting = false;
        preedit = true;
        serialNumber = true;
        ticketForm = false;
        whoText = true;

        File manage_text = new File(FULL_PATH_NAME);
        int based_on_m3 = lines;
        int based_on_m13 = whichCorner;
        if( manage_text.exists() ) {
            readManageText();

            fileName = m[1];
            list_of_items = m[2];
            lines = stringToInteger(m[3]);
            based_on_m3 = lines;

            cell_5 = ( FALSE.equals(m[4]) ) ? false : true;
            firstLine = ( FALSE.equals(m[5]) ) ? false : true;
            noSplitting = ( FALSE.equals(m[6]) ) ? false : true;
            preedit = ( FALSE.equals(m[7]) ) ? false : true;
            rowCount = stringToInteger(m[8]);
            serialNumber = ( FALSE.equals(m[9]) ) ? false : true;
            ticketForm = ( FALSE.equals(m[10]) ) ? false : true;
            destroyWhoText = ( FALSE.equals(m[11]) ) ? false : true;
            toGize = ( FALSE.equals(m[12]) ) ? false : true;
            whichCorner = stringToInteger(m[13]);
            based_on_m13 = whichCorner;
        } else {
// Creating MANAGE_TEXT
            StringBuffer os = new StringBuffer();
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
                os.append(m[line]);
                os.append(NEW_LINE);
            }

            String s = os.toString();
            try {
                BufferedWriter file = new BufferedWriter( new FileWriter(MANAGE_TEXT) );
                file.write(s);
                file.close();
            } catch(Exception e72) {
                error = "Exception e72: " + MANAGE_TEXT;
                createErrorText(error);
                System.exit(ERROR_CODE);
            }

        }

        for(int i = 2; i < count; ++i) {
            argument = args[i];
            if( argument.length() == 0 ) {
                break;
            }

            if( CSV.equals(argument) ) {
                csv = true;
            } else if( EXCLUDE.equals(argument) ) {
                list_of_items = EXCLUDE_TEXT;
            } else if( FREE.equals(argument) ) {
                cell_5 = true;
            } else if( NO_EDITING.equals(argument) ) {
                preedit = false;
            } else if( NO_PREEDITING.equals(argument) ) {
                preedit = false;
            } else if( NO_SPLITTING.equals(argument) ) {
                noSplitting = true;
            } else if( OVERWRITE.equals(argument) ) {
                destroyWhoText = true;
            } else if( QUIT.equals(argument) ) {
                quit = true;
            } else if( REMOVE_LINE_1.equals(argument) ) {
                firstLine = false;
            } else if( TABLE.equals(argument) ) {
                csv = true;
            } else if( TICKET.equals(argument) ) {
                ticketForm = true;
            } else {
                if(whoText) {
                    fileName = argument;
                    whoText = false;
                } else {
                    q = argument.indexOf(COUNT);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        lines = n.number();
                        if( COUNT.equals( n.parameter() ) ) {
                            continue;
                        }

                        lines = based_on_m3;
                    }

                    q = argument.indexOf(DIAGONAL);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        whichCorner = n.number();
                        if( DIAGONAL.equals( n.parameter() ) ) {
                            continue;
                        }

                        whichCorner = based_on_m13;
                    }

                    list_of_items = argument;
                }

            }

        }

        whoText = destroyWhoText;

        OptionalCode op = new OptionalCode(FULL_PATH_NAME, fileName, list_of_items, lines, rowCount, whichCorner, cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, whoText);
        return op;
    }

    public String[] readOptionalText() {
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(OPTIONAL_TEXT) );
            String s;
            for(int i = 0; i < OPTIONAL_TEXT_LINE_COUNT; ++i) {
                optional[i] = buffered.readLine();
                if(optional[i] == null) {
                    break;
                }

            }

            buffered.close();
            return optional;
        } catch (IOException e74) {
            error = "IOException e74: " + OPTIONAL_TEXT;
            createErrorText(error);
            return falseString;
        }

    }

    public Optional(String f) {
        FULL_PATH_NAME = f;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        falseString = new String[OPTIONAL_TEXT_LINE_COUNT];
        falseString[0] = EMPTY;
        optional = new String[OPTIONAL_TEXT_LINE_COUNT];
        OPTIONAL_TEXT = "optional.txt";
    }

    public Optional(String f, String o) {
        FULL_PATH_NAME = f;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        falseString = new String[OPTIONAL_TEXT_LINE_COUNT];
        falseString[0] = EMPTY;
        optional = new String[OPTIONAL_TEXT_LINE_COUNT];
        OPTIONAL_TEXT = o;
    }

}
